      //------------------------------------------------------------------------
      // Program: GetPgmInfo
      //
      // Description: Retrieve program information using the QCLRPGMI API
      //
      // Copyright 2012 Mike Faust
      //------------------------------------------------------------------------
     FQADSPOBJ  if   e             DISK
     Fpgminfo   o  a e             DISK

     dpep              pr                  EXTPGM('GETPGMINFO')
     d parpgm                        10a
     d parlibr                       10a

     dpep              pi
     d parpgm                        10a
     d parlibr                       10a

     dRtvPgmInfo       pr                  ExtPgm('QCLRPGMI')
     d OutputData                 32767a   Options(*varsize)
     d Len                           10i 0 Const
     d Format                         8a   Const
     d PgmName                       20a   Const
     d ErrorCode                           LikeDS(ErrorDS)

     dPGMI0100         ds                  Qualified
     d BytesReturned                 10i 0
     d BytesAvailable                10i 0
     d Name                          10a
     d Library                       10a
     d Owner                         10a
     d Attribute                     10a
     d CrtDateTime                   13a
     d SrcFile                       10a
     d SrcFileLib                    10a
     d SrcMbr                        10a
     d SrcUpdDateTime                13a
     d Observable                     1a
     d UsrPrfOption                   1a
     d UseAdpAut                      1a
     d LogCmd                         1a
     d AlwRTVCLSRC                    1a
     d FixDec                         1a
     d Text                          50a
     d PgmType                        1a
     d TeraspaceEnabled...
     d                                1a
     d                               58a
     d MinParms                      10i 0
     d MaxParms                      10i 0
     d Size                          10i 0
     d AssocSpcSize                  10i 0
     d StaticStgSize                 10i 0
     d AutoStgSize                   10i 0
     d MICount                       10i 0
     d MIODTCount                    10i 0
     d State                          1a
     d CompilerID                    14a
     d OSCanRunOn                     6a
     d SrtSeqTbl                     10a
     d SrtSeqTblLib                  10a
     d LangID                        10a
     d Domain                         1a
     d ConvRequired                   1a
     d                               20a
     d Optimized                      1a
     d PagingPool                     1a
     d UpdPASA                        1a
     d ClrPASA                        1a
     d PagingAmt                      1a
     d                               18a
     d PEPMod                        10a
     d PEPModLib                     10a
     d ActGrpAttr                    30a
     d ObservInfoCompressed...
     d                                1a
     d RuntimeInfoCompressed...
     d                                1a
     d OSCrtOn                        6a
     d SharedActGrp                   1a
     d AlwUpd                         1a
     d CCSID                         10i 0
     d ModCount                      10i 0
     d SrvPgmCount                   10i 0
     d CopyrightCount                10i 0
     d UnresolveRefCount...
     d                               10i 0
     d OSCrtFor                       6a
     d AlwStaticReinit...
     d                                1a
     d CrtDta                         1a
     d AlwBndSrvPgmLibUpd...
     d                                1a
     d ProfilingData                 10a
     d TeraspaceEnabledModules...
     d                                1a
     d StgMdl                         1a
     d                               87a

     dErrorDS          ds                  Qualified
     d BytesProvided                 10i 0 Inz(%Size(ErrorDS))
     d BytesAvailable                10i 0
     d MsgID                          7a
     d                                1a
     d Text                         500a   Varying

     dwrkQualPgm       s             20a

      /free

       read QLIDOBJD;
       dow not %eof();
          wrkQualPgm = ODOBNM + ODLBNM;
          RtvPgmInfo (pgmi0100: 540: 'PGMI0100': wrkQualPgm: ErrorDS);
          if ErrorDS.BytesAvailable = 0;
             clear pgminfor;
             pinNAME = PGMI0100.Name;
             pinLIBRARY = PGMI0100.Library;
             pinOWNER = PGMI0100.Owner;
             pinATTR = PGMI0100.Attribute;
             pinCRTDTTM = PGMI0100.CrtDateTime;
             pinSRCFILE = PGMI0100.SrcFile;
             pinSRCFLLB = PGMI0100.SrcFileLib;
             pinSRCMBR = PGMI0100.SrcMbr;
             pinSRCUPDT = PGMI0100.SrcUpdDateTime;
             pinOBSRVBL = PGMI0100.Observable;
             select;
                when PGMI0100.UsrPrfOption = 'U';
                   pinUSRPROP = '*USER';
                when PGMI0100.UsrPrfOption = 'O';
                   pinUSRPROP = '*OWNER';
             endsl;
             pinUSEADAU = PGMI0100.UseAdpAut;
             write pgminfor;
          endif;
          read QLIDOBJD;
       enddo;
       *inlr = *on;
       return;
